import { DeleteAdGrpcController } from '@modules/ad/interface/grpc-controllers/delete-ad.grpc.controller';
import { CommandBus } from '@nestjs/cqrs';
import { Test, TestingModule } from '@nestjs/testing';

const mockCommandBus = {
  execute: jest.fn(),
};

describe('Delete Ad Grpc Controller', () => {
  let deleteAdGrpcController: DeleteAdGrpcController;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        {
          provide: CommandBus,
          useValue: mockCommandBus,
        },
        DeleteAdGrpcController,
      ],
    }).compile();

    deleteAdGrpcController = module.get<DeleteAdGrpcController>(
      DeleteAdGrpcController,
    );
  });

  afterEach(async () => {
    jest.clearAllMocks();
  });

  it('should be defined', () => {
    expect(deleteAdGrpcController).toBeDefined();
  });

  it('should execute the delete ad command', async () => {
    await deleteAdGrpcController.delete({
      id: '200d61a8-d878-4378-a609-c19ea71633d2',
    });
    expect(mockCommandBus.execute).toHaveBeenCalledTimes(1);
  });
});
